# Copyright (c) 2000-2010, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

%define section     free
%define namedversion     1.1

Name:           xsite
Version:        1.1
Release:        2%{?dist}
Epoch:          0
Summary:        Site generation tool
License:        BSD
Group:          Development/Java
URL:            http://xsite.codehaus.org
Source0:        xsite-1.1.tar.gz
# svn export http://svn.codehaus.org/xsite/tags/xsite-1.1/ 
Source1:        xsite-settings.xml
Source2:        xsite-jpp-depmap.xml
Patch0:         xsite-1.1-pom.patch
Patch99:         xsite-1.1-distribution-temp-pom.patch

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%if %{gcj_support}
BuildRequires:          java-gcj-compat-devel
Requires(post):         java-gcj-compat
Requires(postun):       java-gcj-compat
%endif
%if ! %{gcj_support}
BuildArch:      noarch
%endif

BuildRequires:    jpackage-utils >= 0:1.7.5
BuildRequires:    java-devel >= 0:1.6.0
BuildRequires:    maven2 >= 2.0.8
BuildRequires:    maven2-plugin-antrun
BuildRequires:    maven2-plugin-compiler
BuildRequires:    maven2-plugin-dependency
BuildRequires:    maven2-plugin-install
BuildRequires:    maven2-plugin-jar
BuildRequires:    maven2-plugin-javadoc
BuildRequires:    maven2-plugin-one
BuildRequires:    maven2-plugin-plugin
BuildRequires:    maven2-plugin-resources
BuildRequires:    maven2-default-skin
BuildRequires:    maven-release
BuildRequires:    maven-surefire-maven-plugin
BuildRequires:    maven-surefire-provider-junit4
BuildRequires:    maven-surefire-report-maven-plugin
BuildRequires:    mojo-maven2-plugin-cobertura
BuildRequires:    annotation_1_0_api
BuildRequires:    freemarker >= 0:2.3.6
BuildRequires:    jmock2
BuildRequires:    picocontainer-script
BuildRequires:    servlet_2_4_api
BuildRequires:    sitemesh >= 0:2.4
BuildRequires:    xstream >= 0:1.2.1
BuildRequires:    liberation-fonts

Requires:    jpackage-utils >= 0:1.7.5
Requires:    java >= 0:1.6.0
Requires:    freemarker >= 0:2.3.6
Requires:    picocontainer-script
Requires:    servlet_2_4_api
Requires:    sitemesh >= 0:2.4
Requires:    xstream >= 0:1.2.1
Requires(post):    jpackage-utils >= 0:1.7.5
Requires(postun):  jpackage-utils >= 0:1.7.5

%description
Aims and features
* A full separation between content and style
* Support templatable skin
* Easy configuration sitemap
* Content expressed in plain HTML and not a tool-specific 
  meta-language
* Tool available in several forms, from an embeddable core 
  API to a standalone binary distribution that only requires
  a JRE to maven plugin.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
%{summary}.

%prep
%setup -q -n %{name}-%{namedversion}
cp %{SOURCE1} settings.xml
%patch0 -b .sav0
%patch99 -b .sav99

%build
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" settings.xml

export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p $MAVEN_REPO_LOCAL

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

mvn-jpp \
        -e \
        -s $(pwd)/settings.xml \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Preporting,distribution \
        install javadoc:aggregate

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 %{name}-core/target/%{name}-core-%{namedversion}.jar \
       $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
install -m 644 %{name}-ant/target/%{name}-ant-%{namedversion}.jar \
       $RPM_BUILD_ROOT%{_javadir}/%{name}-ant-%{version}.jar
install -m 644 \
       %{name}-maven-plugin/target/%{name}-maven-plugin-%{namedversion}.jar \
       $RPM_BUILD_ROOT%{_javadir}/%{name}-maven-plugin-%{version}.jar
install -m 644 \
       %{name}-resources/target/%{name}-resources-%{namedversion}.jar \
       $RPM_BUILD_ROOT%{_javadir}/%{name}-resources-%{version}.jar

%add_to_maven_depmap org.codehaus.xsite %{name} %{namedversion} JPP %{name}-parent
%add_to_maven_depmap org.codehaus.xsite %{name}-parent %{namedversion} JPP %{name}-parent
%add_to_maven_depmap org.codehaus.xsite %{name}-core %{namedversion} JPP %{name}
%add_to_maven_depmap org.codehaus.xsite %{name}-ant %{namedversion} JPP %{name}-ant
%add_to_maven_depmap org.codehaus.xsite %{name}-maven-plugin %{namedversion} JPP %{name}-maven-plugin
%add_to_maven_depmap org.codehaus.xsite %{name}-distribution %{namedversion} JPP %{name}-distribution
%add_to_maven_depmap org.codehaus.xsite %{name}-resources %{namedversion} JPP %{name}-resources


(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)
ln -s %{name}-core.jar %{name}.jar

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 pom.xml \
         $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-parent.pom
install -m 644 xsite-core/pom.xml \
         $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom
install -m 644 xsite-ant/pom.xml \
         $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-ant.pom
install -m 644 xsite-maven-plugin/pom.xml \
         $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-maven-plugin.pom
install -m 644 xsite-resources/pom.xml \
         $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-resources.pom
install -m 644 xsite-distribution/pom.xml \
         $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-distribution.pom

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -rf xsite-distribution/target/site/javadoc/* \
                  $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink
rm -rf xsite-distribution/target/site/javadoc

# manual
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -rf xsite-distribution/target/site/* \
                  $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(-,root,root,-)
%{_javadir}/*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*
%if %{gcj_support}
%dir %attr(-,root,root) %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-*%{version}.jar.*
%endif

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}

%files manual
%defattr(-,root,root,-)
%doc %{_docdir}/%{name}-%{version}

%changelog
* Tue Dec 14 2010 Ralph Apel <r.apel at r-apel.de> - 0:1.1-2
- Runtime require picocontainer-script

* Sat Dec 11 2010 Ralph Apel <r.apel at r-apel.de> - 0:1.1-1
- 1.1 for JPP-6

* Fri Apr 03 2009 Ralph Apel <r.apel at r-apel.de> - 0:1.0-0.b9.2.jpp5
- First JPP-5 release (1.0 final needs maven 2.0.9)

* Fri Jul 20 2007 Ralph Apel <r.apel at r-apel.de> - 0:1.0-0.b9.1jpp
- First release
